%Ausregelzeit.m

clear, clc, clf, format long,

Danf = 0.075; Dend = 0.97; dD = 0.001;
%Danf = 0.6; Dend = 0.6; dD = 0.1;
%Danf = 0.383; Dend = 0.383; dD = 0.1;
delta_t = 1e-3; tend = 50.0;
t = 0:delta_t:tend; om0 = 1.0, %om0 = 3.45678, %om0 = 7.196,
%om0 = sqrt(1.5), Danf = 1.0/(2.0*om0), Dend = Danf,

for epsa=[0.02 0.05]
j = 1; epsa,
for D=Danf:dD:Dend
    x = exp(-D*om0*t).*sin(sqrt(1.0-D*D)*om0*t+acos(D))/sqrt(1.0-D*D);
    for i = 2:length(t)
       if abs(x(i-1)) > epsa && abs(x(i)) <= epsa
          tausr_ex = t(i);
       end
    end
D, tausr_ex, tausr_ex_norm = D * om0 * tausr_ex,
tausr_fu = abs(log(epsa*sqrt(1.0-D*D))) / (D * om0),
tausr_fu_norm = D * om0 * tausr_fu,
    
Dp(j) = D;
tausr_exakt(j)    = tausr_ex_norm;
tausr_funktion(j) = tausr_fu_norm;
j = j + 1;
end

if epsa == 0.02
    figure(1)
    plot(Dp,[tausr_exakt' tausr_funktion']), grid on, hold on,
    xlabel ('Dmpfung  D')
    ylabel ('Normierte Ausregelzeiten  D * \omega_0 * t_a_u_s_r')
    title  ('Normierte Ausregelzeiten fr die Fehlerschranke  \epsilon = 0.02')
    text (0.54, 4.25, 'approximiert')
    text (0.625, 3.7, 'exakt')
    plot ([0.408 0.408],[3.25 4.25])
else
    figure(2)
    plot(Dp,[tausr_exakt' tausr_funktion']), grid on, hold 
    xlabel ('Dmpfung  D')
    ylabel ('Normierte Ausregelzeiten  D * \omega_0 * t_a_u_s_r')
    title  ('Normierte Ausregelzeiten fr die Fehlerschranke  \epsilon = 0.05')
    text (0.44, 3.25, 'approximiert')
    text (0.535, 2.8, 'exakt')
    plot ([0.408 0.408],[2.75 3.25])
end
end

%{
Ergebnisse
om0 =    1
epsa =  0.020000000000000
D =  0.600000000000000
tausr_ex =  5.943000000000001
tausr_ex_norm =  3.565800000000000
tausr_fu =  6.891944261237261
tausr_fu_norm =  4.135166556742356

epsa =  0.050000000000000
D =  0.600000000000000
tausr_ex =  5.230000000000000
tausr_ex_norm =  3.138000000000000
tausr_fu =  5.364793041447001
tausr_fu_norm =  3.218875824868201

om0 =  3.456780000000000
epsa =  0.020000000000000
D =  0.600000000000000
tausr_ex =  1.720000000000000
tausr_ex_norm =  3.567396960000000
tausr_fu =  1.993746857259432
tausr_fu_norm =  4.135166556742356

epsa =   0.050000000000000
D =  0.600000000000000
tausr_ex =  1.513000000000000
tausr_ex_norm =  3.138064884000000
tausr_fu =  1.551962532023155
tausr_fu_norm =  3.218875824868201
%}