%Optimierung im Zeitbereich, Minimum-Berechnung
%Zeitquadratgewichtete Betragsregelflche ISTAE
%optimierung_ISTAE_step.m
%Eingangsgre Sprungfunktion

clear, clc, format long

delta_t = 0.0001; tmax = 150.0; nn = round (tmax / delta_t);
x = zeros (nn+1,1); t = 0:delta_t:tmax; tt = (t .* t)';
w = ones(nn+1,1); dfa = 1.0e-5; df_min = 0.75e-5; nmax = 8;

berechne = 1; n = 2; %Ergebnisse
A_ISTAE = 4.331462509007515; ue = 0.012282688119413; tanr = 4.3391;
f1m = 1.62763375;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min / 10 && berechne == 1
    anz_min = 1; j = 0; 
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df   
    G_ISTAE_s(n) = tf(1.0, [1 f1 1]);
    x = step(G_ISTAE_s(n), t);
    A = delta_t * trapz(tt .* abs(w - x));
    if A_min > A + eps
       A_min = A; ue = max(x) - 1.0; f1_min = f1;
       anz_min = anz_min + 1;
       k = 1;
       while x(k) < 1.0
          k = k + 1;
       end
       tanr = t(k);
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, ue, tanr, f1m = f1_min
end
df = df / 2.0;
end
G_ISTAE_s(n) = tf(1.0, [1 f1m 1]);
n, nullstellen = roots(G_ISTAE_s(n).den{1})

berechne = 0; n = 3; %Ergebnisse
A_ISTAE = 7.782373634132065; ue = 0.009008562312750; tanr = 4.6965;
f1m = 2.26958; f2m = 2.01906;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        G_ISTAE_s(n) = tf(1.0, [1 f2 f1 1]);
        x = step(G_ISTAE_s(n), t);
        A = delta_t * trapz(tt .* abs(w - x));
        if A_min > A + eps
           A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
           f1_min = f1; f2_min = f2;
           k = 1;
           while x(k) < 1.0
              k = k + 1;
           end
           tanr = t(k);
        end
    end
end
j = j + 1, df, anz_min
A_ISTAE = A_min, ue, tanr, f1m = f1_min, f2m = f2_min
end
df = df / 2.0;
end
G_ISTAE_s(n) = tf(1.0, [1 f2m f1m 1]);
n, nullstellen = roots(G_ISTAE_s(n).den{1})

berechne = 0; n = 4; %Ergebnisse
A_ISTAE =  12.710022674960312; ue = 0.009677179353167; tanr = 5.1578;
f1m = 2.80712; f2m = 3.56729; f3m = 2.27458;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            G_ISTAE_s(n) = tf(1.0, [1 f3 f2 f1 1]);
            x = step(G_ISTAE_s(n), t);
            A = delta_t * trapz(tt .* abs(w - x));
            if A_min > A + eps
               A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1; 
               f1_min = f1; f2_min = f2; f3_min = f3;
               k = 1;
               while x(k) < 1.0
                  k = k + 1;
               end
               tanr = t(k);
            end
         end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, ue, tanr,
f1m = f1_min, f2m = f2_min, f3m = f3_min 
end
df = df / 2.0;
end
G_ISTAE_s(n) = tf(1.0, [1 f3m f2m f1m 1]);
n, nullstellen = roots(G_ISTAE_s(n).den{1})

berechne = 0; n = 5; %Ergebnisse
A_ISTAE =  19.433547556338961; ue = 0.010940507383863; tanr = 5.6595;
f1m = 3.38688; f2m = 5.14253; f3m = 4.83459; f4m = 2.45161;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
               G_ISTAE_s(n) = tf(1.0, [1 f4 f3 f2 f1 1]);
               x = step(G_ISTAE_s(n), t);
               A = delta_t * trapz(tt .* abs(w - x));
               if A_min > A
                  A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
                  f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                  k = 1;
                  while x(k) < 1.0
                     k = k + 1;
                  end
                  tanr = t(k);
               end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, ue, tanr,
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min
end
df = df / 2.0;
end
G_ISTAE_s(n) = tf(1.0, [1 f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_ISTAE_s(n).den{1})

%Ergebnisse
berechne = 0; n = 6; %Ergebnisse
A_ISTAE =  28.264889558542482; ue = 0.012512969137279; tanr = 6.1798;
f1m = 3.90978; f2m = 7.22615; f3m = 7.82074; 
f4m = 6.06543; f5m = 2.58209;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
                for f5 = f5m-df:df:f5m+df
                    G_ISTAE_s(n) = tf(1.0, [1 f5 f4 f3 f2 f1 1]);
                    x = step(G_ISTAE_s(n), t);
                    A = delta_t * trapz(tt .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5;
                    k = 1;
                    while x(k) < 1.0
                       k = k + 1;
                    end
                    tanr = t(k);
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, ue, tanr,
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min, f5m = f5_min 
end
df = df / 2.0;
end
G_ISTAE_s(n) = tf(1.0, [1 f5m f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_ISTAE_s(n).den{1})

berechne = 0; n = 7; %Ergebnisse
A_ISTAE = 39.513216306006399; ue = 0.014310658094975; tanr = 6.7084;
f1m =  4.46858; f2m = 9.35816; f3m = 12.48261;
f4m = 10.72971; f5m = 7.26468; f6m =  2.68269;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    f1
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    G_ISTAE_s(n) = tf(1.0, [1 f6 f5 f4 f3 f2 f1 1]);
                    x = step(G_ISTAE_s(n), t);
                    A = delta_t * trapz(tt .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3;
                    f4_min = f4; f5_min = f5; f6_min = f6;
                    k = 1;
                    while x(k) < 1.0
                       k = k + 1;
                    end
                    tanr = t(k);
                    end
                    end
                end
            end
        end

    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, ue, tanr,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min 
end
df = df / 2.0;
end
G_ISTAE_s(n) = tf(1.0, [1 f6m f5m f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_ISTAE_s(n).den{1})

berechne = 0; n = 8; %Ergebnisse
A_ISTAE =  53.483553580196265; ue = 0.016243797859913; tanr = 7.2411;
f1m =  4.98845; f2m = 11.97939; f3m = 17.75770; f4m = 19.10197;
f5m = 13.80117; f6m =  8.43891; f7m =  2.76296;
%Minimum-Berechnung
A_min = inf; df = dfa; 
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    f1
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    for f7 = f7m-df:df:f7m+df
                    G_ISTAE_s(n) = tf(1.0, [1 f7 f6 f5 f4 f3 f2 f1 1]);
                    x = step(G_ISTAE_s(n), t);
                    A = delta_t * trapz(tt .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5; f6_min = f6; f7_min = f7;
                    k = 1;
                    while x(k) < 1.0
                    k = k + 1;
                    end
                    tanr = t(k);
                    end
                    end
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, ue, tanr,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min, f7m = f7_min 
end
df = df / 2.0;
end
G_ISTAE_s(n) = tf(1.0, [1 f7m f6m f5m f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_ISTAE_s(n).den{1})

t = 0:10.0*delta_t:10; w = ones(length(t'), 1);
figure (1)
for n = 2:nmax
        x = step(G_ISTAE_s(n), t);
        plot(t, x), hold on, grid on
end
plot(t', w, 'k')
title('ISTAE-Optimierung des Positionsfehlers bei w(t) = E(t)')
xlabel('Zeit t / s'), ylabel('Sprungantwort x(t)')

figure (2)
for n = 2:nmax
        x = step(G_ISTAE_s(n), t);
        plot(t, w - x), hold on, grid on
end
title('ISTAE-Optimierung des Positionsfehlers bei w(t) = E(t)')
xlabel('Zeit t / s'), ylabel('Regeldifferenz x_d(t) = w(t) - x(t)')


%{
n =   2 nullstellen =
  -0.8138 + 0.5811i  -0.8138 - 0.5811i

n =   3 nullstellen =
  -0.6283 + 0.9575i  -0.6283 - 0.9575i
  -0.7625          

n =   4 nullstellen =
  -0.4854 + 1.2185i  -0.4854 - 1.2185i
  -0.6519 + 0.3954i  -0.6519 - 0.3954i

n =   5 nullstellen =
  -0.3804 + 1.4053i  -0.3804 - 1.4053i
  -0.5377 + 0.6911i  -0.5377 - 0.6911i
  -0.6153          

n =   6 nullstellen =
  -0.3027 + 1.5432i  -0.3027 - 1.5432i
  -0.4416 + 0.9202i  -0.4416 - 0.9202i
  -0.5467 + 0.2987i  -0.5467 - 0.2987i

n =   7 nullstellen =
  -0.2441 + 1.6482i  -0.2441 - 1.6482i
  -0.3647 + 1.0999i  -0.3647 - 1.0999i
  -0.4712 + 0.5396i  -0.4712 - 0.5396i
  -0.5227          

n =   8 nullstellen =
  -0.1991 + 1.7306i  -0.1991 - 1.7306i
  -0.3034 + 1.2428i  -0.3034 - 1.2428i
  -0.4026 + 0.7386i  -0.4026 - 0.7386i
  -0.4764 + 0.2400i  -0.4764 - 0.2400i
%}

