%MATLAB Script-file: smith_r2_m.m
clf, clear

lw =1.5; t=0:0.01:10; w0 = 1.0;

KS =1.0; TS =1.0; Tt =2.0;     %nominale Streckenparameter
KSv= KS; TSv= TS; Ttv= Tt;     %variierte Streckenparameter
KR = KS/2.0; TN = TS/2.0;      %T-Summen-PI-Regler ohne Tt
sim('smith_r',t);
subplot(221), plot(x_t.time,x_t.signals.values,'LineWidth',lw)
title('\it{Sprungantwort fr K_S=1,T_S=1 s,T_t=2 s}')
xlabel('Zeit t / s'), ylabel('Sprungantwort x(t)')
grid on

subplot(222)                   %Variation von TS
KSv=KS;Ttv=Tt;
TSv=0.5*TS;
sim('smith_r',t);
plot(x_t.time,x_t.signals.values,'k:','LineWidth',lw), grid on, hold on 
TSv=TS;
sim('smith_r',t);
plot(x_t.time,x_t.signals.values,'k-','LineWidth',lw)
TSv=1.5*TS;
sim('smith_r',t);
plot(x_t.time,x_t.signals.values,'k--','LineWidth',lw)
title('\it{... fr variierte T_S_,_v}')
xlabel('Zeit t / s'), ylabel('Sprungantwort x(t)')
h=legend('T_S_,_v=0.5 s','T_S  =1.0 s','T_S_,_v=1.5 s');
hold off

subplot(223)                   %Variation von Tt
KSv=KS;TSv=TS;
Ttv=0.5*Tt;
sim('smith_r',t);
plot(x_t.time,x_t.signals.values,'k:','LineWidth',lw), grid on, hold on 
Ttv=Tt;
sim('smith_r',t);
plot(x_t.time,x_t.signals.values,'k-','LineWidth',lw)
Ttv=1.5*Tt;
sim('smith_r',t);
plot(x_t.time,x_t.signals.values,'k--','LineWidth',lw)
title('\it{... fr variierte T_t_,_v}')
xlabel('Zeit t / s'), ylabel('Sprungantwort x(t)')
h=legend('T_t_,_v=1.0 s','T_t  =2.0 s','T_t_,_v=3.0 s');
hold off

subplot(224)                   %Variation von KS
TSv=TS;Ttv=Tt;
KSv=0.5*KS;
sim('smith_r',t);
plot(x_t.time,x_t.signals.values,'k:','LineWidth',lw), grid on, hold on 
KSv=KS;
sim('smith_r',t);
plot(x_t.time,x_t.signals.values,'k-','LineWidth',lw)
KSv=1.5*KS;
sim('smith_r',t);
plot(x_t.time,x_t.signals.values,'k--','LineWidth',lw)
title('\it{... fr variierte K_S_,_v}')
xlabel('Zeit t / s'), ylabel('Sprungantwort x(t)')
h=legend('K_S_,_v=0.5','K_S  =1.0','K_S_,_v=1.5');
hold off

