%MATLAB Script-File pdt2_162.m
%Betrag der bertragungsfunktion eines PDT2-Elements

si=linspace(-0.5,0,25);      %sigma (Realteil {s})
om=linspace(-5,5,25);        %omega (Imaginrteil {s})
KRS=1;TV=5;
w0=2;D=0.1;                  %Kennkreisfrequenz, Dmpfung
[SI,OM]=meshgrid(si,om);

rez=KRS*w0^2*(1+SI*TV);      %Realteil des Zhlers von G(s)
imz=KRS*TV*w0^2*OM;          %Imaginrteil des Zhlers von G(s)
num=rez+j*imz;

ren=SI.^2-OM.^2+2*D*w0*SI+w0^2; %Realteil des Nenners von G(s)
imn=2*OM*(SI+D*w0);          %Imaginrteil des Nenners von G(s)
den=ren+j*imn;

G=abs(num./den);             %Betrag der bertragungsfunktion

surf(SI,OM,G)                %3D-Netz, schattiert
grid on                      %kartesische Gitterlinien
title('\it{3D-Netz, schattiert}') %Titel der Grafik
xlabel('\it{Realteil}')      %Bezeichnung der x-Achse
ylabel('\it{Imaginrteil}')  %Bezeichnung der y-Achse
zlabel('\it{Betrag von G}')  %Bezeichnung der z-Achse

pause                        %weiter mit beliebiger Taste
clf                          %Grafik lschen

l=[0.5:1:40];                %Zeilenvektor
subplot(211), contour(SI,OM,G,l) %2D-Hhenlinien fr l
grid on
title('\it{2D-Hhenlinien}')
xlabel('\it{Realteil}')
ylabel('\it{Imaginrteil}')
zlabel('\it{Betrag von G}')

subplot(212), contour3(SI,OM,G,l) %3D-Hhenlinien fr l
grid on
title('\it{3D-Hhenlinien}')
xlabel('\it{Realteil}')
ylabel('\it{Imaginrteil}')
zlabel('\it{Betrag von G}')

pause
clf

subplot(211), mesh(SI,OM,G), view(0,0) %Blickwinkel mit view
grid on
title('\it{3D-Netz; azimuth=0, elevation=0}')
xlabel('\it{Realteil}')
ylabel('\it{Imaginrteil}')
zlabel('\it{Betrag von G}')

subplot(212), mesh(SI,OM,G), view(90,0) %Blickwinkel mit view
grid on
title('\it{3D-Netz; azimuth=90, elevation=0}')
xlabel('\it{Realteil}')
ylabel('\it{Imaginrteil}')
zlabel('\it{Betrag von G}')
