%MATLAB Script-File sinusant_165.m
%Familie von Sinusantworten
KP1=1; T1=4; 			%Parameter
numG1=KP1; denG1=[T1 1];%Zhler- und Nennerpolynom PT1-Element
G1=tf(numG1,denG1);		%bertragungsfunktion G1

t=[0:0.4:20]';         	%Spaltenvektor der Zeitwerte
xa=zeros(length(t),1); 	%Vordefinition Spaltenvektor fr xa
xe=xa;                 	%Vordefinition Spaltenvektor fr xe
k=1;                   	%Nr. der Sinusantwort

for w=logspace(-1.602,0.3979,20) %20 Sinusantworten
    phi=w*t;                     %Winkel phi/rad
    xe=sin(phi);                 %Sinusfunktion
    xa(:,k)=lsim(G1,xe,t);		 %Sinusantwort, Adressierung der Spalte k
    k=k+1;                       %Nr. der Sinusantwort
end

mesh(phi,1:k-1,xa')              %3D-Netz
axis([0,50,0,20,-0.2,1.5])       %Skalierung phi, k, xa
view(-120,30)                    %Blickwinkel
title('{\itPT}_1{\it-Sinusantworten}') %Titel der Grafik
xlabel('\it{phi/rad}')           %Beschriftung der x-Achse
ylabel('\it{Sinusantwort Nr.}')  %Beschriftung der y-Achse
zlabel('{\itx}_a{\it(t)}')       %Beschriftung der z-Achse





